import { Plugin } from 'esbuild';

interface IPluginSettings {
    /**
     * Log detailed info.
     * Defaults to **false**.
     */
    verbose?: boolean;
    /**
     * Use custom parsing RegExp.
     */
    regExp?: RegExp;
    /**
     * File path regExp.
     * Defaults to `/\.[jt]sx?/`.
     */
    filePath?: RegExp;
    /**
     * Require ///.
     * Defaults to **true**.
     */
    requireTripleSlash?: boolean;
    /**
     * Fill line with spaces instead of commenting out.
     * Defaults to **false**.
     */
    fillWithSpaces?: boolean;
    /**
     * Variables for the expressions.
     * Defaults to **process.env**.
     */
    variables?: Record<string, any>;
}
declare function ifdefPlugin(settings?: IPluginSettings): Plugin;

export { type IPluginSettings, ifdefPlugin as default };
